<template>
  <div>
    <v-data-table
      :headers="inputHeaders"
      :items="inputParams"
      sort-by="orden"
      height="200"
      fixed-header
      hide-default-footer
      item-key="index"
    >
      <template v-slot:item.orden="{ item }">
        <v-text-field
          v-model.number.trim="item.orden"
          placeholder="Orden"
          type="number"
        ></v-text-field>
      </template>
      <template v-slot:item.name="{ item }">
        <v-text-field
          v-model.trim="item.name"
          placeholder="Nombre"
        ></v-text-field>
      </template>
      <template v-slot:item.value="{ item }">
        <v-text-field
          v-model.trim="item.value"
          placeholder="Valor"
        ></v-text-field>
      </template>
      <template v-slot:item.oracle_type="{ item }">
        <v-select v-model="item.oracle_type" :items="oracleTypesIn"></v-select>
      </template>
      <template v-slot:top>
        <v-toolbar flat color="white">
          <v-toolbar-title>Parametros de entrada</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-btn color="primary" dark class="mb-2" @click="addInputParam"
            >Nuevo parametro</v-btn
          >
        </v-toolbar>
      </template>
      <template v-slot:item.delete="{ item }">
        <v-icon small @click="deleteInputParam(item)">
          mdi-delete
        </v-icon>
      </template>
      <template v-slot:no-data>
        Sin parametros de entrada
      </template>
    </v-data-table>
    <v-data-table
      :headers="outputHeaders"
      :items="outputParams"
      sort-by="orden"
      height="200"
      fixed-header
      hide-default-footer
      item-key="index"
    >
      <template v-slot:item.orden="{ item }">
        <v-text-field
          v-model.number.trim="item.orden"
          placeholder="Orden"
          type="number"
        ></v-text-field>
      </template>
      <template v-slot:item.name="{ item }">
        <v-text-field
          v-model.trim="item.name"
          placeholder="Nombre"
        ></v-text-field>
      </template>
      <template v-slot:item.oracle_type="{ item }">
        <v-select v-model="item.oracle_type" :items="oracleTypesOut"></v-select>
      </template>
      <template v-slot:top>
        <v-toolbar flat color="white">
          <v-toolbar-title>Parametros de salida</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-btn color="primary" dark class="mb-2" @click="addOutputParam"
            >Nuevo parametro</v-btn
          >
        </v-toolbar>
      </template>
      <template v-slot:item.delete="{ item }">
        <v-icon small @click="deleteOutputParam(item)">
          mdi-delete
        </v-icon>
      </template>
      <template v-slot:no-data>
        Sin parametros de salida
      </template>
    </v-data-table>
  </div>
</template>
<script>
export default {
  name: "Component-Params",
  props: {
    setParams: Function
  },
  data: () => ({
    outputHeaders: [
      {
        text: "Orden",
        align: "start",
        sortable: false,
        value: "orden"
      },
      {
        text: "Nombre",
        align: "start",
        sortable: false,
        value: "name"
      },
      { text: "Tipo de Dato", value: "oracle_type", sortable: false },
      { text: "Eliminar", align: "center", value: "delete", sortable: false }
    ],
    inputHeaders: [
      {
        text: "Orden",
        align: "start",
        sortable: false,
        value: "orden"
      },
      {
        text: "Nombre",
        align: "start",
        sortable: false,
        value: "name"
      },
      { text: "Valor", value: "value", sortable: false },
      { text: "Tipo de Dato", value: "oracle_type", sortable: false },
      { text: "Eliminar", align: "center", value: "delete", sortable: false }
    ],
    oracleTypesIn: ["VARCHAR", "NUMERIC", "DATE", "TIME", "TIMESTAMP"],
    oracleTypesOut: [
      "VARCHAR",
      "NUMERIC",
      "DATE",
      "TIME",
      "TIMESTAMP",
      "CURSOR"
    ],
    inputParams: [],
    outputParams: [],
    inoutParams: [],
    defaultOutputParam: {
      index: -1,
      orden: 0,
      name: "",
      type: "OUT",
      oracle_type: "VARCHAR"
    },
    defaultInputParam: {
      index: -1,
      orden: 0,
      name: "",
      value: "",
      type: "IN",
      oracle_type: "VARCHAR"
    }
  }),
  watch: {
    inputParams: {
      deep: true,
      handler: function() {
        this.mergeParams();
      }
    },
    outputParams: {
      deep: true,
      handler: function() {
        this.mergeParams();
      }
    }
  },
  created() {},
  methods: {
    deleteInputParam(item) {
      const index = this.inputParams.indexOf(item);
      this.inputParams.splice(index, 1);
    },
    deleteOutputParam(item) {
      const index = this.outputParams.indexOf(item);
      this.outputParams.splice(index, 1);
    },
    addInputParam() {
      this.defaultInputParam.index = this.inputParams.length;
      this.inputParams.push(JSON.parse(JSON.stringify(this.defaultInputParam)));
    },
    addOutputParam() {
      this.defaultOutputParam.index = this.outputParams.length;
      this.outputParams.push(
        JSON.parse(JSON.stringify(this.defaultOutputParam))
      );
    },
    mergeParams() {
      this.inoutParams = [];
      let inputParams = JSON.parse(JSON.stringify(this.inputParams));
      let outputParams = JSON.parse(JSON.stringify(this.outputParams));
      inputParams.sort((a, b) => a.orden - b.orden);
      outputParams.sort((a, b) => a.orden - b.orden);
      inputParams.forEach((item) => {
        delete item.orden;
        delete item.index;
        this.inoutParams.push(item);
      });
      outputParams.forEach((item) => {
        delete item.orden;
        delete item.index;
        this.inoutParams.push(item);
      });
      this.setParams(this.inoutParams);
    }
  }
};
</script>
